
// ----------------------------------------------------- read pulse sensor
void readPulseSensor() {
  pulseSamples[0] = analogRead(pulseInputPin);

  float newPulseMin = 1024;                             // reset max and min values
  float newPulseMax = 0;

  for (int i = 79; i > 0; i--) {                        // move pulse samples in ring buffer
    pulseSamples[i] = pulseSamples[i - 1];
    if (i < 20) {                                       // for the newest 20 samplings:
      if (pulseSamples[i] > newPulseMax) newPulseMax = pulseSamples[i];     // save max gsr value
      if (pulseSamples[i] < newPulseMin) newPulseMin = pulseSamples[i];     // save min gsr value
    }
  }

  pulseMax = (pulseMax * 10 + newPulseMax) / 11;        // filter min and max
  pulseMin = (pulseMin * 10 + newPulseMin) / 11;
  pulseThreshold = (pulseMax - pulseMin) * 3 / 5 + pulseMin; // calculate threshold
}

// ----------------------------------------------------- heartbeat detection
void detectHeartBeat() {
  pHeartBeat = heartBeat;                               // save heartBeat value from previous cycle;
  if (pulseSamples[0] > pulseThreshold && heartBeat == false) { // heartbeat detected
    heartBeat = true;

    for (int i = 19; i > 0; i--) {                      // move beat times in ring buffer
      beatTime[i] = beatTime[i - 1];
    }
    beatTime[0] = millis();                             // add new beat time at the beginning of ringbuffer

    float pulseDuration = beatTime[0] - beatTime[10];   // add time of last ten pulses
    pulseDuration /= 10;                                // average pulse duration in milliseconds
    oldBpm = bpm;                                       // save old bpm
    bpm = 60000 / pulseDuration;                        // calculate beats per minute
  }
  if (pulseSamples[0] < pulseThreshold && heartBeat == true) {   // if sample drops below threshold -> beat off
    heartBeat = false;
  }
}
